%{!?scl:%global pkg_name %{name}}

%global features FedoraFeatures
%global repos repositories
%global pkgs FedoraPackages

Name:           preupgrade-assistant
Version:        2.1.9
Release:        4%{?dist}
Summary:        Preupgrade assistant performs assessment of the system
License:        GPLv3+
URL:            https://github.com/upgrades-migrations/preupgrade-assistant
Source0:        https://github.com/upgrades-migrations/%{name}/archive/%{version}.tar.gz
Source1:        macros.preupgrade-assistant
Source2:        check.ini
Source3:        check.sh
Source4:        solution.txt
Source5:        repositories.ini
Source6:        repositories.py
Source7:        repositories.txt
Source8:        rpm.ini
Source9:        rpm.sh
Source10:       rpm.txt
Patch01:        preupgrade-assistant-do-not-ship-ui.patch
Patch02:        preupgrade-assistant-python3-fixes.patch
Patch03:        preupgrade-assistant-create-group.patch
BuildArch:      noarch
BuildRequires:  rpm-devel
%if %{?_with_check:1}%{!?_with_check:0}
BuildRequires:  perl-XML-XPath
%endif
BuildRequires:  openscap-engine-sce >= 0:1.2.8-1
BuildRequires:  openscap-utils >= 0:1.2.8-1
BuildRequires:  openscap >= 0:1.2.8-1
Requires:       openscap-engine-sce >= 0:1.2.8-1
Requires:       openscap-utils >= 0:1.2.8-1
Requires:       openscap >= 0:1.2.8-1
Obsoletes:      %{name}-features < 2.1.7
Obsoletes:      %{name}-repos < 2.1.7
BuildRequires:  python-devel
BuildRequires:  python-setuptools
BuildRequires:  python-six
BuildRequires:  python-requests
BuildRequires:  rpm-python
BuildRequires:  python-kickstart
BuildRequires:  python-libs
Requires:       python-kickstart
Requires:       python-setuptools
Requires:       python-six
Requires:       python-requests
Requires:       rpm-python

%{load:%{SOURCE1}}

%description
Preupgrade assistant performs assessment of the system from
the "upgradeability" point of view. Such analysis includes check for removed
packages, packages replaced by partially incompatible packages, changes in
libraries, users and groups and various services. Report of this analysis
can help the admin with the inplace upgrade - by identification of potential
troubles and by mitigating some of the incompatibilities. Data gathered
by preupgrade assistant can be used for the "cloning" of the system - new,
clean installation of the system, as close as possible to the old Fedora setup.
In addition, it provides some postupgrade scripts which are supposed to finish
migration after the installation of Fedora system.

%package devel
Summary:        Devel package for building contents
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description devel
Contains macros needed for building preupgrade-assistant contents
and scripts for generating contents.


%package modules
Summary:        Set of modules for upgrade to the highest version
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description modules
Contains modules for assessment system and modules for kickstart generation

%prep
%setup -q -n %{name}-%{version}
%patch01 -p1
%patch02 -p1
%patch03 -p1

rm -rf preup_ui
rm -rf ui-conf

mkdir -p %{preupgrade_name}/%{features}
cp -a %{SOURCE2} %{SOURCE3} %{SOURCE4} %{preupgrade_name}/%{features}/
mkdir -p %{preupgrade_name}/%{repos}
cp -a %{SOURCE5} %{SOURCE6} %{SOURCE7} %{preupgrade_name}/%{repos}/
mkdir -p %{preupgrade_name}/%{pkgs}
cp -a %{SOURCE8} %{SOURCE9} %{SOURCE10} %{preupgrade_name}/%{pkgs}/

%build
%{__python2} setup.py build
%{__python2} ./preupg-xccdf-compose %{preupgrade_name}/
sed -i "s|PREUPGRADE_CONFIG\s*=.*|PREUPGRADE_CONFIG = \"$RPM_BUILD_ROOT/etc/preupgrade-assistant.conf\"|g" \
    preup/script_api.py

%check
# Tests are now skipped
cp -a preup-conf/preupgrade-assistant.conf $RPM_BUILD_ROOT/etc/preupgrade-assistant.conf
%{__python2} setup.py test

%install

#Preupgrade snd Premigrate tuff
mkdir -p -m 755 $RPM_BUILD_ROOT%{_datadir}/preupgrade/{xsl,common,postupgrade.d,kickstart}

mkdir -p -m 755 $RPM_BUILD_ROOT%{_datadir}/sectool-sce/
mkdir -p -m 755 $RPM_BUILD_ROOT%{_docdir}/preupgrade

install -d -m 755 $RPM_BUILD_ROOT%{_libdir}/preupgrade
install -d -m 755 $RPM_BUILD_ROOT%{_localstatedir}/log/preupgrade

mkdir -p -m 755 $RPM_BUILD_ROOT%{preupgrade_dir}/%{repos}
install -p -m 755 %{SOURCE6} $RPM_BUILD_ROOT%{preupgrade_dir}/%{repos}/repositories.py
install -p -m 644 %{SOURCE7} $RPM_BUILD_ROOT%{preupgrade_dir}/%{repos}/repositories.txt
install -p -m 644 %{preupgrade_name}-%preupg_results/%{repos}/group.xml \
    $RPM_BUILD_ROOT%{preupgrade_dir}/%{repos}/group.xml

mkdir -p -m 755 $RPM_BUILD_ROOT%{preupgrade_dir}/%{pkgs}
install -p -m 755 %{SOURCE8} $RPM_BUILD_ROOT%{preupgrade_dir}/%{pkgs}/rpm.sh
install -p -m 644 %{SOURCE9} $RPM_BUILD_ROOT%{preupgrade_dir}/%{pkgs}/rpm.txt
install -p -m 644 %{preupgrade_name}-%preupg_results/%{pkgs}/group.xml \
    $RPM_BUILD_ROOT%{preupgrade_dir}/%{pkgs}/group.xml

%{__install} -p -m 644 -D %SOURCE1 $RPM_BUILD_ROOT%{_rpmconfigdir}/macros.d/macros.preupgrade-assistant

%{__python2} setup.py install --skip-build --root=$RPM_BUILD_ROOT

%global egg_name %(echo %{name} | sed s/-/_/)

%{__install} -p -m 644 -D man/preupg.1 $RPM_BUILD_ROOT%{_mandir}/man1/preupg.1

rm -rf  ${RPM_BUILD_ROOT}%{python2_sitelib}/preup_ui/

rm -f ${RPM_BUILD_ROOT}%{_bindir}/preup_ui_manage
rm -rf  ${RPM_BUILD_ROOT}%{_datadir}/premigrate
rm -f ${RPM_BUILD_ROOT}%{_bindir}/premigrate


%files
%license LICENSE
%{_bindir}/preupg
%{_bindir}/preupg-kickstart-generator
%dir %{python2_sitelib}/preup
%{python2_sitelib}/preup/*.py*
%dir %{python2_sitelib}/preup/kickstart
%{python2_sitelib}/preup/kickstart/*
%{python2_sitelib}/%{egg_name}*.egg-info
# Preupgrade stuff
%dir %{_datadir}/preupgrade
%{_sysconfdir}/preupgrade-assistant.conf
%{_datadir}/preupgrade/common
%{_datadir}/preupgrade/common.sh
%{_datadir}/preupgrade/postupgrade.d
%{_datadir}/preupgrade/README.kickstart
%{_datadir}/preupgrade/README
%dir %{_datadir}/preupgrade/kickstart
%{_datadir}/preupgrade/kickstart/*
%doc README
%{_localstatedir}/log/preupgrade
%{_mandir}/man1/*
%dir %{python2_sitelib}/preuputils
%{python2_sitelib}/preuputils/*

%files devel
%{_bindir}/preupg-create-group-xml
%{_bindir}/preupg-xccdf-compose
%{_bindir}/preupg-content-creator
%{_rpmconfigdir}/macros.d/macros.preupgrade-assistant
%dir %{python2_sitelib}/preup/creator
%{python2_sitelib}/preup/creator/*

%files modules
%{preupgrade_dir}/%{repos}
%{preupgrade_dir}/%{pkgs}

%changelog
* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.1.9-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.1.9-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Tue Sep 06 2016 Petr Hracek <phracek@redhat.com> - 2.1.9-2
- Include upstream tests

* Mon Sep 05 2016 Petr Hracek <phracek@redhat.com> - 2.1.9-1
- New upstream version (#1360324)

* Tue Jul 19 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.1.7-3
- https://fedoraproject.org/wiki/Changes/Automatic_Provides_for_Python_RPM_Packages

* Mon Jul 18 2016 Petr Hracek <phracek@redhat.com> - 2.1.7-2
- Fix modules

* Thu Jul 14 2016 Petr Hracek <phracek@redhat.com> - 2.1.7-1
- New upstream release (#1328852)

* Thu Mar 24 2016 Petr Hracek <phracek@redhat.com> - 2.1.5-1
- New upstream release (#1289957)

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 2.1.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Nov 19 2015 Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl> - 2.1.1-4
- Remove circular build dependency
- Fix preupg script to run under Python 3

* Fri Nov 13 2015 Petr Stodulka <pstodulk@redhat.com> - 2.1.1-3
- again just rebuild because of weird rebuild..

* Tue Nov 10 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.1.1-2
- Rebuilt for https://fedoraproject.org/wiki/Changes/python3.5

* Fri Oct 30 2015 Petr Hracek <phracek@redhat.com> - 2.1.1-1
- New upstream release (#1253095)

* Tue Jun 16 2015 Petr Hracek <phracek@redhat.com> - 0.11.12-6
- content for repositories (#1225812)

* Fri May 29 2015 Petr Hracek <phracek@redhat.com> - 0.11.12-5
- Fix for exception case in Python 3

* Tue May 26 2015 Petr Hracek <phracek@redhat.com> - 0.11.12-4
- Fix print issue #1224892

* Wed May 20 2015 Petr Stodulka <pstodulk@redhat.com> - 0.11.12-3
- fixed wrong substitution for solution texts

* Tue May 19 2015 Petr Stodulka <pstodulk@redhat.com> - 0.11.12-2
- added patch for updating solution.txt caused by splitting reports 

* Fri May 15 2015 Petr Hracek <phracek@redhat.com> - 0.11.12-1
- Rebase to new upstream version 0.11.12

* Fri Apr 10 2015 Petr Stodulka <pstodulk@redhat.com> - 0.11.10-1
- Rebase to new upstream version 0.11.10
- modified patch0

* Mon Mar 09 2015 Petr Hracek <phracek@redhat.com> 0.11.7-1
- Initial rpm
